from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String

Guppy_Visualization_V0_1_0 = CommandToolBuilder(tool="guppy_visualization", base_command=["guppy", "visualization"], inputs=[ToolInput(tag="in_visualization", input_type=String(), position=0, doc=InputDocumentation(doc="fat                     makes trees with edges fattened in proportion to the number of reads")), ToolInput(tag="in_heat", input_type=String(), position=1, doc=InputDocumentation(doc="maps an an arbitrary vector of the correct length to the tree")), ToolInput(tag="in_sing", input_type=String(), position=2, doc=InputDocumentation(doc="makes one tree for each query sequence, showing uncertainty")), ToolInput(tag="in_tog", input_type=String(), position=3, doc=InputDocumentation(doc="makes a tree with each of the reads represented as a pendant edge")), ToolInput(tag="in_bary", input_type=String(), position=0, doc=InputDocumentation(doc="draws the barycenter of a placement collection on the reference tree")), ToolInput(tag="in_ed_pl", input_type=String(), position=1, doc=InputDocumentation(doc="calculates the EDPL uncertainty values for a collection of pqueries")), ToolInput(tag="in_error", input_type=String(), position=2, doc=InputDocumentation(doc="finds the error between two placefiles")), ToolInput(tag="in_fpd", input_type=String(), position=3, doc=InputDocumentation(doc="calculates various alpha diversity metrics of placefiles")), ToolInput(tag="in_kr", input_type=String(), position=4, doc=InputDocumentation(doc="calculates the Kantorovich-Rubinstein distance and corresponding p-values")), ToolInput(tag="in_kr_heat", input_type=String(), position=5, doc=InputDocumentation(doc="makes a heat tree")), ToolInput(tag="in_pc_a", input_type=String(), position=6, doc=InputDocumentation(doc="performs edge principal components")), ToolInput(tag="in_rare_fact", input_type=String(), position=7, doc=InputDocumentation(doc="calculates phylogenetic rarefaction curves")), ToolInput(tag="in_split_if_y", input_type=String(), position=8, doc=InputDocumentation(doc="writes out differences of masses for the splits of the tree")), ToolInput(tag="in_squash", input_type=String(), position=9, doc=InputDocumentation(doc="performs squash clustering")), ToolInput(tag="in_uni_frac", input_type=String(), position=10, doc=InputDocumentation(doc="calculates unifrac on two or more placefiles")), ToolInput(tag="in_classification", input_type=String(), position=11, doc=InputDocumentation(doc="classify                outputs classification information in a tabular or SQLite format")), ToolInput(tag="in_classify_rdp", input_type=String(), position=12, doc=InputDocumentation(doc="converts RDP output to something resembling guppy classify output")), ToolInput(tag="in_to_rdp", input_type=String(), position=13, doc=InputDocumentation(doc="convert a reference package to a format RDP wants")), ToolInput(tag="in_utilities", input_type=String(), position=14, doc=InputDocumentation(doc="adcl                    calculates ADCL for each pquery in a placefile")), ToolInput(tag="in_check", input_type=String(), position=15, doc=InputDocumentation(doc="checks placefiles for common problems")), ToolInput(tag="in_compress", input_type=String(), position=16, doc=InputDocumentation(doc="compresses a placefile's pqueries")), ToolInput(tag="in_de_multi", input_type=String(), position=17, doc=InputDocumentation(doc="splits apart placements with multiplicity, undoing a round procedure")), ToolInput(tag="in_dist_mat", input_type=String(), position=18, doc=InputDocumentation(doc="prints out a pairwise distance matrix between the edges")), ToolInput(tag="in_filter", input_type=String(), position=19, doc=InputDocumentation(doc="filters one or more placefiles by placement name")), ToolInput(tag="in_info", input_type=String(), position=20, doc=InputDocumentation(doc="writes the number of leaves of the reference tree and the number of pqueries")), ToolInput(tag="in_islands", input_type=String(), position=21, doc=InputDocumentation(doc="finds the mass islands of one or more pqueries")), ToolInput(tag="in_merge", input_type=String(), position=22, doc=InputDocumentation(doc="merges placefiles together")), ToolInput(tag="in_mft", input_type=String(), position=23, doc=InputDocumentation(doc="Multi-Filter and Transform placefiles")), ToolInput(tag="in_o_graph", input_type=String(), position=24, doc=InputDocumentation(doc="finds the mass islands of one or more pqueries")), ToolInput(tag="in_rare_fy", input_type=String(), position=25, doc=InputDocumentation(doc="performs rarefaction on collections of placements")), ToolInput(tag="in_red_up", input_type=String(), position=26, doc=InputDocumentation(doc="restores duplicates to deduped placefiles")), ToolInput(tag="in_round", input_type=String(), position=27, doc=InputDocumentation(doc="clusters the placements by rounding branch lengths")), ToolInput(tag="in_to_csv", input_type=String(), position=28, doc=InputDocumentation(doc="turns a placefile into a csv file")), ToolInput(tag="in_to_json", input_type=String(), position=29, doc=InputDocumentation(doc="converts old-style .place files to .jplace placement files")), ToolInput(tag="in_trim", input_type=String(), position=30, doc=InputDocumentation(doc="trims placefiles down to only containing an informative subset of the mass"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Guppy_Visualization_V0_1_0().translate("wdl", allow_empty_container=True)

